Enumeration
  #da; disassembler
EndEnumeration
; ///////////////////////////////////////////////////////////////////////////////
; /////// A Z80 disassembler - works under Win32 For now
; ////// Author : Matthew Porth
; ///// Copyright : 2004 - Matthew Porth - however - If you email me I'll let
; ////              you use it commerically Or non-comercially With no restrictions
; ///               accept you MUST contact me
; // Version 0.08 - another compile option jr cc, -1 decompiles To RST cc, $38
; //              - added compiler time option To switch between JP (HL) And JP HL
; // Version 0.07 - added output of 16 bit load targets (often memory addresses)
; // Version 0.06 - IXH/IXL And IYH/IYL swapped (H xlats2 I?H And L xlats2 I?L
; // Version 0.05 - change in ED LD/CP/IN/OUT logic
; // Version 0.04 - fixed ED LDI/CPI/INI/OUTI opcodes.
; // Version 0.03 - added forward decl of dis() (duh!)
; //              - swapped index byte Read And opcode Read in FD/DD+CB opcodes
; //              - fixed double opcode bug in single op statements e.g. HALT HALT
; //              - changed ixf/iyf To a single variable
; //              - more opcodes stored in arrays (DAA/SCF And CB group rotates)
; //              - fixed undoc DD/FD+CB opcodes (now prints "temp" reg properly)
; // Version 0.02 - acceptable aligning of mneumnonics (6 chars)
; //              - better calling conventions (still sucks though)
; //              - negative indices in IX/IY index modes printed properly
; //              - this header changed ;-)
; // Version 0.01 - horribly unfinished.
; 
; #include <stdlib.h>
; #include <stdio.h>
; #include <conio.h>
; #include <string.h>
; 
; //#define PRINT_JUMP_TABLES
; // convert jr cc, -1 To rst cc, 0x38
; //#define _CONDITIONAL_RESET_
; // converts jp (hl) To jp hl (same For ix/iy)
; //#define _NO_INDIRECT_REG_JUMPS_
; 
; typedef unsigned __int8 byte;
; typedef unsigned __int16 word;
; 
; // here - List of predefined entry points - probably includes
; // 0,8,16,24,32,40,48,56 And 66 As minimum (reset And RST vectors, 
; 
; // absolute max.... err... reference count instead??? very lazy though... double arrays?
; word jtargs[65536];
Global Dim jtargs.u(65536)
; word dtargs[65536];
Global Dim dtargs.u(65536)

Global jt.u=0; unsigned jt = 0;
Global dt.u=0; unsigned dt = 0;
             ; // memory image
Global Dim memory.a(65536); byte memory[65536];
                          ; // inital instruction pointers
Global ip.u=0             ; word ip = 0;
                          ; // used For printing out bytes of instructions in disassembly
Global startip.u = 0      ; word startip = 0;
                          ; // flags (this needs To be a little different)
Global idx_off.a=0        ; #define idx_off       0
Global idx_ix.a=2         ; #define idx_ix        2
Global idx_iy.a=3         ; #define idx_iy        3
Global idxmode.a = idx_off; byte idxmode = idx_off;
                          ; // index byte
Global idxbyte.a = 0      ; byte idxbyte = 0;
                          ; // hex LUT.
                          ; char hexes[] = "0123456789ABCDEF";
Global ipp.u
Declare doCB()
Declare doED()
Declare dis()
; void dis();
; 
; void note(char *note, word Data = 0);
; 
; void disasm(unsigned ipinit, unsigned ipmax) {
;     ip = ipinit;
; 
;     While (ip < ipmax) {
;         startip = ip;
;         idxmode = idx_off;
;         dis();
;     }
; #ifdef PRINT_JUMP_TABLES
;     word x;
; 
;     printf("jtargs\n");
;     For (x = 0; x < jt; x++) {
;         printf("%04x\n", jtargs[x]);
;     }
;     printf("dtargs\n");
;     For (x = 0; x < dt; x++) {
;         printf("%04x\n", dtargs[x]);
;     }
; #endif
; }
; 
; word addjtarg(word addr) {
;     jtargs[jt++] = addr;
;     note("target word ", jtargs[jt-1]);
;     Return addr;
; }
; 
; void addjtarg(byte offs) {
;     // sign extension bullshit
;     jtargs[jt++] = (signed)(ip) + char(offs);
;     note("target byte ", jtargs[jt-1]);
; }
; 
; word adddtarg(word addr) {
;     dtargs[dt++] = addr;
;     note("target word ", dtargs[dt-1]);
;     Return addr;
; }
; 
; void prsip() {
;     printf("%04X ", startip);
;     // now... up To 6 bytes (12 characters)
;     For (word x = startip; x < ip; x++) {
;         printf("%c%c", hexes[memory[x] >> 4], hexes[memory[x] & 0xf]);
;     }
;     // how many was that???
;     If ((ip - startip) < 6) {
;         For (word x = 0; x < (6 - (ip - startip)); x++) {
;             printf("  ");
;         }
;     }
; }
; 
; void prop(char *pszop) {
;     printf("%s",pszop);
;     For (word x = 0; x < 6 - strlen(pszop); x++) printf(" ");
; }
; 
; void opcode(char *op) {
;     prsip();
;     prop(op);
;     printf("\n");
; }
; 
; void opcode(char *op, byte p1) {
;     prsip();
;     prop(op);
;     printf("$%02X\n", unsigned(p1));
; }
; 
; void opcode(char *op, word p1) {
;     prsip();
;     prop(op);
;     printf("$%04X\n", unsigned(p1));
; }
; 
; void opcode(char *op, char *p1, byte p2, bool ind = false) {
;     prsip();
;     prop(op);
;     If (ind) printf("(%s), $%02X\n", p1, unsigned(p2));
;     Else printf("%s, $%02X\n", p1, unsigned(p2));
; }
; 
; void opcode(char *op, char *p1, word p2, bool ind = false) {
;     prsip();
;     prop(op);
;     If (ind) printf("%s, $(%04X)\n", p1, unsigned(p2));
;     Else printf("%s, $%04X\n", p1, unsigned(p2));
; }
; 
; void opcode(char *op, word p1, char *p2, bool ind = false) {
;     prsip();
;     prop(op);
;     If (ind) printf("$(%04X), %s\n", unsigned(p1),p2);
;     Else printf("$%04X, %s\n", unsigned(p1),p2);
; }
; 
; void opcode(char *op, char *p1) {
;     prsip();
;     prop(op);
;     printf("%s\n", p1);
; }
; 
; void opcode(char *op, char *p1, char *p2) {
;     prsip();
;     prop(op);
;     printf("%s, %s\n", p1, p2);
; }
; 
; void opcode(char *op, byte p1, char *p2, bool ind = false) {
;     prsip();
;     prop(op);
;     If (ind) printf("$(%02X), %s\n", unsigned(p1), p2);
;     Else printf("$%02X, %s\n", unsigned(p1), p2);
; }
; 
; void opcode(char *op, byte p1, char *p2, char *p3) {
;     prsip();
;     prop(op);
;     printf("$%02X, %s, %s\n", p1, p2, p3);
; }
; 
; void note(char *note, word Data) {
;     printf(";;; %s %04x\n", note, Data);
; }
; 
Procedure.a getbyte(); byte getbyte() {
  b.a=memory(ip)     ;     byte b = memory[ip];
  ip+1               ;     ip++;
  ProcedureReturn b  ;     Return b;
EndProcedure         ; }
                     ; 
Procedure getidxbyte(); byte getidxbyte() {
  idxbyte = getbyte() ;     Return idxbyte = getbyte();
  ;Debug idxbyte
EndProcedure     

Procedure.u getword(); word getword() {
  w.u= (memory(ip)):ip+1; | (memory(ip + 1) << 8);     word w = word(memory[ip]) | (word(memory[ip + 1]) << 8);
                        ;ip+2;     ip += 2;
  w.u=w|((memory(ip))<<8):ip+1
  ProcedureReturn w;     Return w;
EndProcedure       ; }
                   ; 
                   ; byte getidxbyte() {
                   ;     Return idxbyte = getbyte();
                   ; }
                   ; 
                   ; // fwd decls
                   ; void doCB();
                   ; void doED(); 
                   ; 
Procedure doDD()   ; void doDD() {
  idxmode = idx_ix ;     idxmode = idx_ix;
  dis()            ;
EndProcedure       ; }

Procedure doFD(); void doFD() {
  idxmode = idx_iy;     idxmode = idx_iy;
  dis()           ;
EndProcedure      ; }
                  ; 
                  ; char pszix[] = "(IX+$xx)";
                  ; char psziy[] = "(IY+$xx)";
                  ; 
                  ; void put8bit(char *dst, byte b) {
                  ;     // sign
                  ;     dst[0] = (b & 0x80)?'-':'+';
                  ;     // doesn't really need to be here now but will in the future
                  ;     dst[1] = '$';
                  ;     // If neg then make it positive
                  ;     If (b & 0x80) b = ~b + 1;
                  ;     dst[2] = hexes[b >> 4];
                  ;     dst[3] = hexes[b & 0xf];
                  ; }
                  ; 
                  ; 
                  ; char *reg8(unsigned u) {
                  ;     If (u == 0) Return "B";
                  ;     Else If (u == 1) Return "C";
                  ;     Else If (u == 2) Return "D";
                  ;     Else If (u == 3) Return "E";
                  ;     Else If (u == 4 && idxmode == idx_ix) Return "IXH";
                  ;     Else If (u == 4 && idxmode == idx_iy) Return "IYH";
                  ;     Else If (u == 4) Return "H";
                  ;     Else If (u == 5 && idxmode == idx_ix) Return "IXL";
                  ;     Else If (u == 5 && idxmode == idx_iy) Return "IYL";
                  ;     Else If (u == 5) Return "L";
                  ;     Else If (u == 6 && idxmode == idx_ix) {
                  ;         put8bit(&(pszix[3]), idxbyte);
                  ;         Return pszix;
                  ;     } Else If (u == 6 && idxmode == idx_iy) {
                  ;         put8bit(&(psziy[3]), idxbyte);
                  ;         Return psziy;
                  ;     }
                  ;     Else If (u == 6) Return "(HL)";
                  ;     Else If (u == 7) Return "A";
                  ;     Else Return 0;
                  ; }
                  ; 
                  ; // As above but DON'T add the idxmode to the subscript
                  ; char *reg8noidx(unsigned u) {
                  ;     If (u == 0) Return "B";
                  ;     Else If (u == 1) Return "C";
                  ;     Else If (u == 2) Return "D";
                  ;     Else If (u == 3) Return "E";
                  ;     Else If (u == 4) Return "H";
                  ;     Else If (u == 5) Return "L";
                  ;     Else If (u == 6) Return "(HL)";
                  ;     Else If (u == 7) Return "A";
                  ;     Else Return 0;
                  ; }
                  ; 
                  ; char *reg16(unsigned u) {
                  ;     If (u == 0) Return "BC";
                  ;     Else If (u == 1) Return "DE";
                  ;     Else If (u == 2 && idxmode == idx_ix) Return "IX";
                  ;     Else If (u == 2 && idxmode == idx_iy) Return "IY";
                  ;     Else If (u == 2) Return "HL";
                  ;     Else If (u == 3) Return "SP";
                  ;     Else Return 0;
                  ; }
                  ; 
                  ; char *gethl() { Return reg16(2); }
                  ; 
                  ; // non stack versions
                  ; char *reg16st(unsigned u) {
                  ;     If (u == 0) Return "BC";
                  ;     Else If (u == 1) Return "DE";
                  ;     Else If (u == 2 && idxmode == idx_ix) Return "IX";
                  ;     Else If (u == 2 && idxmode == idx_iy) Return "IY";
                  ;     Else If (u == 2) Return "HL";
                  ;     Else If (u == 3) Return "AF";
                  ;     Else Return 0;
                  ; }
                  ; 
                  ; char *ccs[8] = { "NZ", "Z", "NC", "C", "PO", "PE", "P", "M" };
                  ; char *cc(unsigned u) { Return ccs[u]; }
                  ; 
                  ; char *aluops[8] = { "ADD", "ADC", "SUB", "SBC", "AND", "XOR", "OR", "CP" };
                  ; char *aluop(unsigned u) { Return aluops[u]; }
                  ; 
                  ; char *g0gxg7ops[] = { "RLCA", "RRCA", "RLA", "RRA", "DAA", "CPL", "SCF", "CCF" };
                  ; 
Procedure.l disp(ch.a)
  If ch&128
    d.l=-(ch!255+1)
  Else
    d.l=ch
  EndIf
  ProcedureReturn d.l
EndProcedure

Procedure.s by(bb.a)
  ProcedureReturn "$"+RSet(Hex(bb),2,"0")
EndProcedure
Procedure.s wo(ww.u)
  ProcedureReturn "$"+RSet(Hex(ww),4,"0")
EndProcedure

Procedure opcode(op.s)
  ;Debug wo(startip)+" "+op
  
  SetGadgetText(#da, GetGadgetText(#da)+Chr(13)+Chr(10)+wo(startip)+" "+op)
EndProcedure

Procedure.s reg16(u.a); char *reg16(unsigned u) {
  
  Select u
    Case 0:r16.s="BC";     If (u == 0) Return "BC";
    Case 1:r16.s="DE";     Else If (u == 1) Return "DE";
    Case 2:
      ;     Else If (u == 2 && idxmode == idx_ix) Return "IX";
      If idxmode = idx_ix
        r16.s="IX"
      ElseIf idxmode = idx_iy
        r16.s="IY"
      Else
        r16.s="HL"
      EndIf
      ;     Else If (u == 2 && idxmode == idx_iy) Return "IY";
      ;     Else If (u == 2) Return "HL";
    Case 3:r16.s="SP";     Else If (u == 3) Return "SP";
                     ;     Else Return 0;
    Default:
      r16.s="error!"
  EndSelect
  ProcedureReturn r16
EndProcedure; }
            ; 
Procedure.s gethl(); char *gethl() { Return reg16(2); }
  ProcedureReturn reg16(2)
EndProcedure

; char pszix[] = "(IX+$xx)";
; char psziy[] = "(IY+$xx)";
; 
; void put8bit(char *dst, byte b) {
;     // sign
;     dst[0] = (b & 0x80)?'-':'+';
;     // doesn't really need to be here now but will in the future
;     dst[1] = '$';
;     // If neg then make it positive
;     If (b & 0x80) b = ~b + 1;
;     dst[2] = hexes[b >> 4];
;     dst[3] = hexes[b & 0xf];
; }
; 
; 
Procedure.s cc(u.a)
  Select u
    Case 0: jc.s="NZ"
    Case 1: jc.s="Z"
    Case 2: jc.s="NC"
    Case 3: jc.s="C"
    Case 4: jc.s="PO"
    Case 5: jc.s="PE"
    Case 6: jc.s="P"
    Case 7: jc.s="M"
    Default:
      jc.s="cond poimi"
  EndSelect
  ProcedureReturn jc
EndProcedure

Procedure.s g0gxg7ops(u.a);char *g0gxg7ops[] = { "RLCA", "RRCA", "RLA", "RRA", "DAA", "CPL", "SCF", "CCF" };
  g0.s="huj poimi"
  Select u
    Case 0: g0="RLCA"
    Case 1: g0="RRCA"
    Case 2: g0="RLA"
    Case 3: g0="RRA"
    Case 4: g0="DAA"
    Case 5: g0="CPL"
    Case 6: g0="SCF"
    Case 7: g0="CCF"
  EndSelect
  ProcedureReturn g0
EndProcedure

Procedure.s aluop(u.a)
  Select u
    Case 0:alu.s="ADD"
    Case 1:alu.s="ADC"
    Case 2:alu.s="SUB"
    Case 3:alu.s="SBC"
    Case 4:alu.s="AND"
    Case 5:alu.s="XOR"
    Case 6:alu.s="OR"
    Case 7:alu.s="CP"
    Default:alu.s="bad alu"
  EndSelect
  ProcedureReturn alu+" "
EndProcedure
Procedure.s reg8(u.a); char *reg8(unsigned u) {
  
  Select u
      
    Case 0: r8.s="B";     If (u == 0) Return "B";
    Case 1: r8.s="C";     Else If (u == 1) Return "C";
    Case 2: r8.s="D";     Else If (u == 2) Return "D";
    Case 3: r8.s="E";     Else If (u == 3) Return "E";
      
    Case 4:
      If idxmode = idx_ix:r8.s="IXH"
        ;     Else If (u == 4 && idxmode == idx_ix) Return "IXH";
      ElseIf idxmode = idx_iy:r8.s="IYH"
        ;     Else If (u == 4 && idxmode == idx_iy) Return "IYH";
      Else
        ;     Else If (u == 4) Return "H";
        r8.s="H"
      EndIf
      
    Case 5:
      ;     Else If (u == 5 && idxmode == idx_ix) Return "IXL";
      ;     Else If (u == 5 && idxmode == idx_iy) Return "IYL";
      ;     Else If (u == 5) Return "L";
      If idxmode = idx_ix:r8.s="IXL"
      ElseIf idxmode = idx_iy:r8.s="IYL"
      Else
        r8.s="L"
      EndIf
      
    Case 6:
      If idxmode = idx_ix;     Else If (u == 6 && idxmode == idx_ix) {
                         ;         put8bit(&(pszix[3]), idxbyte);
                         ;         Return pszix;
        ;getidxbyte()
        disp.l=disp(idxbyte)
        r8.s="(IX"
        If disp>=0
          r8+"+"+by(idxbyte)+")"
        Else
          r8+Str(disp)+")"
        EndIf
        
        ;     } Else If (u == 6 && idxmode == idx_iy) {
        ;         put8bit(&(psziy[3]), idxbyte);
        ;         Return psziy;
      ElseIf idxmode = idx_iy
        ;getidxbyte()
        disp.l=disp(idxbyte)
        r8.s="(IY"
        If disp>=0
          r8+"+"+by(idxbyte)+")"
        Else
          r8+Str(disp)+")"
        EndIf
        
        ;     }
        ;     Else If (u == 6) Return "(HL)";
      Else
        r8.s="(HL)"
      EndIf
      ;     Else If (u == 7) Return "A";
    Case 7:
      r8.s="A"
      ;     Else Return 0;
    Default: r8.s="huj poimi"
  EndSelect
  ProcedureReturn r8
EndProcedure; }


; // non stack versions
Procedure.s reg16st(u.a); char *reg16st(unsigned u) {
  Select u
    Case 0:r16s.s="BC";     If (u == 0) Return "BC";
    Case 1:r16s.s="DE";     Else If (u == 1) Return "DE";
    Case 2:
      ;     Else If (u == 2 && idxmode == idx_ix) Return "IX";
      If idxmode = idx_ix
        r16s.s="IX"
        ;     Else If (u == 2 && idxmode == idx_iy) Return "IY";
      ElseIf idxmode = idx_iy
        r16s.s="IY"
        ;     Else If (u == 2) Return "HL";
      Else
        r16s.s="HL"
      EndIf
    Case 3:r16s.s="AF";     Else If (u == 3) Return "AF";
                      ;     Else Return 0;
    Default:r16s.s="Bad stack"
  EndSelect
  ProcedureReturn r16s
EndProcedure; }

; // As above but DON'T add the idxmode to the subscript
Procedure.s reg8noidx(u.a); char *reg8noidx(unsigned u) {
  Select u
    Case 0:r8.s="B";     If (u == 0) Return "B";
    Case 1:r8.s="C";     Else If (u == 1) Return "C";
    Case 2:r8.s="D";     Else If (u == 2) Return "D";
    Case 3:r8.s="E";     Else If (u == 3) Return "E";
    Case 4:r8.s="H";     Else If (u == 4) Return "H";
    Case 5:r8.s="L";     Else If (u == 5) Return "L";
    Case 6:r8.s="(HL)";     Else If (u == 6) Return "(HL)";
    Case 7:r8.s="A"   ;     Else If (u == 7) Return "A";
    Default: r8.s="error"
      ;     Else Return 0;
  EndSelect; }
  ProcedureReturn r8
EndProcedure



Procedure dis()
  
  ; ipp=ip
  b.a = getbyte();byte b = getbyte();
                 ; // split 7/6 5/4/3 2/1/0
                 ; // that is the _general_ organisation of the Z80
                 ; // some are organized vertically, some horizontally
  g0.a = b >> 6  ;
  g1.a = (b >> 3) & 7;
  g2.a = b & 7       ;
  
  ;     // primitive - ifdec(x) - tests For zero And decrements...
  ;     // executes code If x is zero before decementing
  Select g0
    Case 0:;If (g0 == 0) {
      Select g2
        Case 0:;If (g2 == 0) {
          Select g1
            Case 0:opcode("NOP");If g1 == 0) opcode("NOP");
            Case 1:opcode("EX AF,AF'");If (g1 == 1) opcode("EX", "AF", "AF'");
                                      ;// jump target is ip (already updated To Next instruction) + offset
            Case 2:                   ;If (g1 == 2) {
              o.a = getbyte()         ;
                                      ;addjtarg(o);
              jtargs(jt)=ip+disp(o):jt+1
              
              ;                 // add condtional rst??? should be possbile DJNZ -1 will call RST $38
              ;                 // If B is Not zero... bit weird though.
              opcode("DJNZ "+wo(ip+disp(o)));opcode("DJNZ", o);
                                            ;}
            Case 3:                         ;If (g1 == 3) {
              o.a = getbyte()               ;
                                            ;addjtarg(o);
              jtargs(jt)=ip+disp(o):jt+1
              opcode( "JR "+wo (ip+disp(o) ) );opcode("JR", o);
                                              ;}
            Default:                          ;If (g1 > 3) {
              o.a = getbyte()                 ;
                                              ;Debug pc
                                              ;Debug "end rst"
              opcode( "JR "+cc(g1-4)+","+wo(ip+disp(o)) )
              ;End
              ; #ifdef _CONDITIONAL_RESET_
              ;                 If (o == 0xff) opcode("RST", cc(g1 - 4), byte(0x38));
              ;                 Else {
              ;                     addjtarg(o);
              ;                     opcode("JR", cc(g1 - 4), o);
              ;                 }
              ; #else
              ;                 addjtarg(o);
              ;                 opcode("JR", cc(g1 - 4), o);
              ; #endif
          EndSelect;}
                   ;}
        Case 1:    ;If (g2 == 1) {
          If g1 & 1
            opcode("ADD "+gethl()+","+reg16(g1 >> 1));
          Else
            addr.u=getword()
            dtargs(dt)= addr
            dt+1
            opcode("LD "+reg16(g1 >> 1)+","+wo(addr)); adddtarg(getword()));
          EndIf                                      ;}
        Case 2:                                      ;If (g2 == 2) {
          Select g1
            Case 0:opcode("LD (BC),A");If (g1 == 0) opcode("LD", "(BC)", "A");
            Case 1:opcode("LD A,(BC)");Else If (g1 == 1) opcode("LD", "A", "(BC)");
            Case 2:opcode("LD (DE),A");Else If (g1 == 2) opcode("LD", "(DE)", "A");
            Case 3:opcode("LD A,(DE)");Else If (g1 == 3) opcode("LD", "A", "(DE)");
            Case 4:                   ;Else If (g1 == 4) {
                                      ;                 opcode("LD", adddtarg(getword()), gethl(), true);
                                      ;             }
              addr.u=getword()
              dtargs(dt)= addr
              dt+1
              opcode("LD  ("+wo(addr)+"),"+gethl())
              
            Case 5:;Else If (g1 == 5) opcode("LD", gethl(), adddtarg(getword()), true);
              addr.u=getword()
              dtargs(dt)= addr
              dt+1
              opcode("LD "+gethl()+",("+wo(addr)+")")
              
            Case 6:;Else If (g1 == 6) opcode("LD", adddtarg(getword()), "A", true);
              addr.u=getword()
              dtargs(dt)= addr
              dt+1
              opcode("LD  ("+wo(addr)+"),A")
              
            Case 7:;Else If (g1 == 7) opcode("LD", "A", adddtarg(getword()), true);
              addr.u=getword()
              dtargs(dt)= addr
              dt+1
              opcode("LD  A,("+wo(addr)+")")
          EndSelect;}
        Case 3:    ;If (g2 == 3) {    // 16 bit inc/decs
          If g1 & 1
            opcode("DEC "+reg16(g1 >> 1));
          Else
            opcode("INC "+reg16(g1 >> 1));
          EndIf
          ;}
        Case 4:;If (g2 == 4) {
          If g1 = 6 And idxmode <> idx_off;If (g1 == 6) getidxbyte();
            getidxbyte()
          EndIf;}
          opcode("INC "+reg8(g1));
        Case 5:                  ;If (g2 == 5) {
          If g1 = 6 And idxmode <> idx_off             ;If (g1 == 6)
            getidxbyte()         ;
          EndIf                  ;}
          opcode("DEC "+reg8(g1));
          
        ;Case 6: opcode("LD "+reg8(g1)+","+by(getbyte()));If (g2 == 6) opcode("LD", reg8(g1), getbyte()); LD(IX+*),*
        Case 6:
          If g1 = 6 And idxmode <> idx_off             ;If (g1 == 6)
            getidxbyte()         ;
          EndIf                  ;}
          opcode("LD "+reg8(g1)+","+by(getbyte()))
        Case 7: opcode(g0gxg7ops(g1))                   ;If (g2 == 7) opcode(g0gxg7ops[g1]);
      EndSelect                                         ;    }
    Case 1:                                             ;Else If (g0 == 1) {
      If g1 = 6 And g2 = 6                              ;(g1 == 6 && g2 == 6)
        opcode("HALT")                                  ;
      Else                                              ; {
        If g2 = 6 And idxmode <> idx_off                ;(g2 == 6 && idxmode != idx_off)
          getidxbyte()                                  ;
          opcode("LD "+reg8noidx(g1)+","+reg8(g2))      ;
        ElseIf g1 = 6 And idxmode <> idx_off            ;(g1 == 6 && idxmode != idx_off); {
          getidxbyte()                                  ;
          opcode("LD "+reg8(g1)+","+reg8noidx(g2))      ;
        Else
          opcode("LD "+reg8(g1)+","+reg8(g2));
        EndIf
      EndIf;}
    Case 2:;} Else If (g0 == 2) {
           ;!!!fix?
          If g2 = 6  And idxmode <> idx_off
            getidxbyte()
          EndIf
      
If g1=0 Or g1=1 Or g1=3
  opcode(aluop(g1)+"A,"+reg8(g2));
Else
  opcode(aluop(g1)+" "+reg8(g2));
EndIf

    Case 3:                     ;} Else If (g0 == 3) {
      Select g2
          ;If g2 = 0
        Case 0:   opcode("RET "+cc(g1));
        Case 1:                        ;ElseIf g2 = 1
          If (g1 & 1)
            If g1 = 1
              opcode("RET");
            ElseIf g1 = 3
              opcode("EXX");
            ElseIf g1 = 5
              ; #ifdef _NO_INDIRECT_REG_JUMPS_
              ;                     opcode("JP", gethl());
              ; #else
              ;                     If (idxmode == idx_ix) opcode("JP","(IX)");
              ;                     Else If (idxmode == idx_iy) opcode("JP","(IY)");
              ;                     Else opcode("JP","(HL)");
              ; #endif
              ;                 }
              If idxmode = idx_ix
                opcode("JP (IX)")
              ElseIf idxmode = idx_iy
                opcode("JP (IY)")
              Else
                opcode("JP (HL)")
              EndIf
              
            ElseIf g1 = 7
              opcode("LD SP,"+gethl());
            EndIf
          Else
            opcode("POP "+reg16st(g1 >> 1));
          EndIf
        Case 2:;ElseIf g2 = 2
          addr.u=getword()
          dtargs(jt)= addr
          jt+1
          opcode("JP "+cc(g1)+","+wo(addr)); addjtarg(getword()));
        Case 3:                            ;ElseIf g2 = 3
          Select g1
            Case 0:;If (g1 == 0) {
              addr.u=getword()
              dtargs(jt)= addr
              jt+1
              
              opcode("JP "+wo(addr));, addjtarg(getword()));
                                    ;}
            Case 1: doCB()          ;Else If (g1 == 1) doCB();
            Case 2:                 ;Else If (g1 == 2) opcode("OUT", getbyte(), "A", true);
              opcode("OUT ("+by(getbyte())+ "),A")
            Case 3:;Else If (g1 == 3) opcode("IN", "A", getbyte(), true);
              opcode("IN A,("+by(getbyte())+")")
            Case 4:;Else If (g1 == 4) opcode("EX", "(SP)", gethl());
              opcode("EX (SP),"+gethl())
            Case 5:;Else If (g1 == 5) opcode("EX", "DE", "HL");
              opcode("EX DE,HL")
            Case 6:;Else If (g1 == 6) opcode("DI");
              opcode("DI")
            Case 7:;Else If (g1 == 7) opcode("EI");
              opcode("EI")                       ;
          EndSelect
        Case 4:;} Else If (g2 == 4) {
          addr.u=getword()
          dtargs(jt)= addr
          jt+1
          opcode("CALL "+cc(g1)+","+wo(addr));addjtarg(getword()));
        Case 5:                              ;} Else If (g2 == 5) {
          If g1 & 1
            Select g1
              Case 1:;If (g1 == 1) {
                addr.u=getword()
                dtargs(jt)= addr
                jt+1
                opcode("CALL "+wo(addr));, addjtarg(getword()));
              Case 3:doDD()             ;} Else If (g1 == 3) doDD();
              Case 5:doED()             ;Else If (g1 == 5) doED();
              Case 7
                ;idxmode = idx_iy
                doFD();Else If (g1 == 7) doFD();
            EndSelect
          Else
            opcode("PUSH "+reg16st(g1 >> 1));
          EndIf                             ;}
        Case 6:                             ;} Else If (g2 == 6) {
          ;opcode(aluop(g1)+" "+by(getbyte())+";!!!!!!!!!!!!!!!!!!!!")
          If g1=0 Or g1=1 Or g1=3
            opcode(aluop(g1)+"A,"+by(getbyte()))
          Else
            opcode(aluop(g1)+by(getbyte()))
          EndIf
          
        Case 7:;} Else If (g2 == 7) {
          opcode("RST "+by(g1 * 8));
      EndSelect                    ;}
  EndSelect                        ;}
                                   ;EndSelect;}
EndProcedure                       ;}

;char *cbrops[8] = { "RLC", "RRC", "RL", "RR", "SLA", "SRA", "SLL", "SRL" };

Procedure.s cbrops(u.a)
  cb.s="unk CB"
  Select u
    Case 0:cb="RLC"
    Case 1:cb="RRC"
    Case 2:cb="RL"
    Case 3:cb="RR"
    Case 4:cb="SLA"
    Case 5:cb="SRA"
    Case 6:cb="SLL"
    Case 7:cb="SRL"
  EndSelect
  ProcedureReturn cb
EndProcedure

Procedure doCB();void doCB(void) {
                ;If (idxmode != idx_off) getidxbyte();
  If idxmode <> idx_off
    getidxbyte();
  EndIf
  b.a = getbyte();
  g0.a = b >> 6  ;
  g1.a = (b >> 3) & 7;
  g2.a = b & 7       ;
  
  Select g0
    Case 0:;If (g0 == 0) {
      If (idxmode <> idx_off And g2 <> 6);If (idxmode != idx_off && (g2 != 6)) {
        opcode(cbrops(g1)+" "+reg8(6)+" "+reg8noidx(g2));
      Else
        opcode(cbrops(g1)+" "+reg8(g2));
      EndIf
    Case 1:;} Else If (g0 == 1) {
      If idxmode <> idx_off;(idxmode != idx_off)
        opcode("BIT "+Str(g1)+","+reg8(6));
      Else
        opcode("BIT "+Str(g1)+","+reg8(g2));
      EndIf                               ;}
    Case 2:                               ;Else If (g0 == 2) {
      If idxmode <> idx_off And g2 <> 6   ;(idxmode != idx_off && g2 != 6)
        opcode ("RES "+Str(g1)+","+reg8(6)+" "+reg8noidx(g2));
      Else
        opcode("RES "+Str(g1)+","+reg8(g2));
      EndIf                               ;}
    Case 3:                               ;Else If (g0 == 3) {
      If (idxmode <> idx_off And g2 <> 6) ;(idxmode != idx_off && g2 != 6)
        opcode ("SET "+Str(g1)+","+reg8(6)+" "+reg8noidx(g2));
      Else
        opcode("SET "+Str(g1)+","+reg8(g2));
      EndIf
  EndSelect;}
           ;}
EndProcedure; }
            ; 
            ; char *edautoops[16] = { "LDI", "LDD", "LDIR", "LDDR", "CPI", "CPD", "CPIR", "CPDR",
            ;                         "INI", "IND", "INIR", "INDR", "OUTI", "OUTD", "OUTIR", "OUTDR" };
            ; 
Procedure.s edautoops(u.a)
  ed.s="ED unkn"
  Select u
    Case 0:ed.s="LDI"
    Case 1:ed.s="LDD"
    Case 2:ed.s="LDIR"
    Case 3:ed.s="LDDR"
    Case 4:ed.s="CPI"
    Case 5:ed.s="CPD"
    Case 6:ed.s="CPIR"
    Case 7:ed.s="CPDR"
    Case 8:ed.s="INI"
    Case 9:ed.s="IND"
    Case 10:ed.s="INIR"
    Case 11:ed.s="INDR"
    Case 12:ed.s="OUTI"
    Case 13:ed.s="OUTD"
    Case 14:ed.s="OUTIR"
    Case 15:ed.s="OUTDR"
  EndSelect
  ProcedureReturn ed
EndProcedure

Procedure doED(); void doED() {
  idxmode = idx_off;
                   ;      Debug "ED"
                   ;      End
                   ; 
  b.a = getbyte()  ;
  g0.a = b >> 6    ;
  g1.a = (b >> 3) & 7;
  g2.a = b & 7       ;
                     ; 
  Select g0
      ;     If (g0 == 0 || g0 == 3) opcode("NOP");
    Case 0,3: opcode("NOP") 
      
    Case 1:
      ;     If (g0 == 1) {
      Select g2
        Case 0:;         If (g2 == 0) {
               ;             If (g1 != 6) opcode("IN", reg8(g1), "(C)");
               ;             Else opcode("IN","(C)");
          If g1<>6
            opcode("IN "+reg8(g1)+",(C)")
          Else
            opcode("IN,(C);????????????????")
          EndIf
        Case 1:;         } Else If (g2 == 1) {
               ;             If (g1 != 6) opcode("OUT", "(C)", reg8(g1));
          If g1<>6
            opcode("OUT (C),"+reg8(g1))
          Else
            opcode("OUT (C),0;?????????????????")
          EndIf
          ;             Else opcode("OUT","(C)", byte(0));
        Case 2:;         } Else If (g2 == 2) {
               ;             If (g1 & 1) opcode("ADC", "HL", reg16(g1 >> 1));
               ;             Else opcode("SBC", "HL", reg16(g1 >> 1));
          If g1&1
            opcode("ADC HL,"+reg16(g1 >> 1))
          Else
            opcode("SBC HL,"+reg16(g1 >> 1))
          EndIf
        Case 3:;         } Else If (g2 == 3) {
               ;             If (g1 & 1) opcode("LD", reg16(g1 >> 1), getword(), true);
               ;             Else opcode("LD", getword(), reg16(g1>> 1), true);
          If g1&1
            opcode("LD "+reg16(g1 >> 1)+",("+wo(getword())+")")
          Else
            opcode( "LD ("+wo(getword())+"),"+reg16(g1>> 1) )
          EndIf
        Case 4:;         } Else If (g2 == 4) {
               ;             opcode("NEG");
          opcode("NEG")
        Case 5:;         } Else If (g2 == 5) {
               ;             If (g1 == 1) opcode("RETI");
               ;             Else opcode("RETN");
          If g1=1
            opcode("RETI")
          Else
            opcode("RETN")
          EndIf
        Case 6:;         } Else If (g2 == 6) {
               ;             g1 &= 3;
               ;             If (g1 > 0) g1--;
               ;             opcode("IM", g1);
          g1=g1&3
          If g1>0:g1-1:EndIf
          opcode("IM "+Str(g1))
        Case 7:;         } Else If (g2 == 7) {
          Select g1
            Case 0: opcode("LD I,A");             If (g1 == 0) opcode("LD","I","A");
            Case 1: opcode("LD R,A");             If (g1 == 1) opcode("LD","R","A");
            Case 2: opcode("LD A,I");             If (g1 == 2) opcode("LD","A","I");
            Case 3: opcode("LD A,R");             If (g1 == 3) opcode("LD","A","R");
            Case 4: opcode("RRD")   ;             If (g1 == 4) opcode("RRD");
            Case 5: opcode("RLD")   ;             If (g1 == 5) opcode("RLD");
            Case 6: opcode("NOP")   ;             If (g1 == 6) opcode("NOP");
            Case 7:opcode("NOP")    ;             If (g1 == 7) opcode("NOP");
          EndSelect
      EndSelect;         }
    Case 2:    ;     } Else If (g0 == 2) {
      If g1&4 And (255-g2)&4;         If ((g1 & 4) & (~g2 & 4)) {
                            ;             opcode(edautoops[(g1 & 3) | (g2 << 2)]);
                            ;         }
        opcode(edautoops((g1 & 3) | (g2 << 2)))
      Else
        opcode("NOP");         Else { opcode("NOP"); }
      EndIf
  EndSelect;     }
EndProcedure; }


Procedure disasm(ipinit.u, ipmax.u)
  ; void disasm(unsigned ipinit, unsigned ipmax) {
  ip = ipinit;     ip = ipinit;
             ; 
  While (ip < ipmax);     While (ip < ipmax) {
    startip = ip    ;         startip = ip;
    idxmode = idx_off;         idxmode = idx_off;
    dis()            ;         dis();
  Wend               ;     }
                     ; #ifdef PRINT_JUMP_TABLES
                     ;     word x;
                     ; 
                     ;     printf("jtargs\n");
                     ;     For (x = 0; x < jt; x++) {
                     ;         printf("%04x\n", jtargs[x]);
                     ;     }
                     ;     printf("dtargs\n");
                     ;     For (x = 0; x < dt; x++) {
                     ;         printf("%04x\n", dtargs[x]);
                     ;     }
                     ; #endif
EndProcedure         ; }


  If OpenWindow(0, 0, 0, 640, 480, "Z80 disassembler 0.9a", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
    StringGadget(#da, 0,  0, 640, 460, "",#ES_MULTILINE|#ES_AUTOVSCROLL|#WS_VSCROLL|#WS_HSCROLL|#ESB_DISABLE_LEFT|#ESB_DISABLE_RIGHT)
    
    EnableGadgetDrop(#da,#PB_Drop_Files, #PB_Drag_Copy)
;     ReadFile(0,"48k.rom")
; For i=0 To 16383
;   memory(i)=ReadAsciiCharacter(0)
; Next i
; CloseFile(0)

i=0
;ReadFile(0,"tt.bin")
; ReadFile(0,"allinstructions.bin")
; While Not Eof(0)
;   memory(i)=ReadAsciiCharacter(0)
;   i+1
; Wend
; CloseFile(0)

; sa=$0
; disasm(sa,sa+$40)

Repeat 
  eve=WaitWindowEvent()
  Select eve
    Case #PB_Event_GadgetDrop
            Files$ = EventDropFiles()
            Files$ = StringField(Files$, 1, Chr(10))
            fs.l=FileSize(Files$)
            If fs>=0
              If ReadFile(0,Files$)
                ii.u=0
                ;For i=0 To 16383
                While Not Eof(0)
                  memory(ii)=ReadAsciiCharacter(0)
                  ii+1
                Wend;Next i
                CloseFile(0)
                disasm(0,fs)
              Else
                MessageRequester("Error","Error read "+Files$,#PB_MessageRequester_Ok )
              EndIf
            EndIf
            
  EndSelect
Until eve = #PB_Event_CloseWindow
  EndIf

End

; ReadFile(0,"48k.rom")
; For i=0 To 16383
;   memory(i)=ReadAsciiCharacter(0)
; Next i
; CloseFile(0)
; 
; i=0
; ;ReadFile(0,"tt.bin")
; ReadFile(0,"allinstructions.bin")
; While Not Eof(0)
;   memory(i)=ReadAsciiCharacter(0)
;   i+1
; Wend
; CloseFile(0)
; 
; sa=$571
; disasm(sa,sa+$40)
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 336
; FirstLine = 336
; Folding = ----
; EnableUnicode
; EnableXP
; UseIcon = disz80.ico
; Executable = disz80.exe